package com.iconplus.smartproc.controller;

import com.iconplus.smartproc.helper.model.EmptyResponse;
import com.iconplus.smartproc.model.request.ListPermissionRequest;
import com.iconplus.smartproc.repository.PermissionRepository;
import com.iconplus.smartproc.service.permission.PutUpdatePermissionService;
import org.springframework.web.bind.annotation.*;

@CrossOrigin(origins = "${fe.server}", allowCredentials = "true")
@RestController
@RequestMapping("/api/permission")
public class PermissionController {

    private PermissionRepository permissionRepository;
    private PutUpdatePermissionService putUpdatePermissionService;

    public PermissionController(PermissionRepository permissionRepository,
                                PutUpdatePermissionService putUpdatePermissionService) {
        this.permissionRepository = permissionRepository;
        this.putUpdatePermissionService = putUpdatePermissionService;
    }

    @PutMapping("/{roleId}")
    public EmptyResponse editPermissionRole(@PathVariable Long roleId, @RequestBody ListPermissionRequest listPermissionRequest) {
        listPermissionRequest.setRoleId(roleId);
        return putUpdatePermissionService.execute(listPermissionRequest);
    }

}
