package com.iconplus.smartproc.model.entity;

import com.iconplus.smartproc.helper.base.BaseEntity;
import lombok.AllArgsConstructor;
import lombok.Builder;
import lombok.Data;
import lombok.NoArgsConstructor;
import org.hibernate.annotations.Type;

import javax.persistence.*;
import java.math.BigDecimal;
import java.sql.Date;
import java.sql.Timestamp;

@Data
@Builder
@AllArgsConstructor
@NoArgsConstructor
@Entity
@Table(name = "drp_pengadaan")
public class DrpPengadaan extends BaseEntity {

    @Id
    @GeneratedValue(strategy = GenerationType.IDENTITY)
    private Long id;

    @Column(name = "drp_id")
    private Long drpId;

    @Column(name = "nomor")
    private String nomor;

    @Column(name = "nama_pengadaan")
    private String namaPengadaan;

    @Column(name = "lokasi_id")
    private Long lokasiId;

    @Column(name = "jenis_pengadaan_id")
    private Long jenisPengadaanId;

    @Column(name = "unit_inisiator_id")
    private Long unitInisiatorId;

    @Column(name = "pagu")
    private BigDecimal pagu;

    @Column(name = "sumber_dana_id")
    private Long sumberDanaId;

    @Column(name = "supply_positioning_matrix_id")
    private Long supplyPositioningMatrixId;

    @Column(name = "metode_pengadaan_id")
    private Long metodePengadaanId;

    @Column(name = "metode_penyampaian_id")
    private Long metodePenyampaianId;

    @Column(name = "jenis_kontrak_id")
    private Long jenisKontrakId;

    @Column(name = "strategi_pengadaan_id")
    private Long strategiPengadaanId;

    @Column(name = "rencana_tanggal")
    private Date rencanaTanggal;

    @Column(name = "target_tanggal")
    private Date targetTanggal;

    @Column(name = "hpe")
    private BigDecimal hpe;

    @Column(name = "is_active")
    @Type(type = "org.hibernate.type.NumericBooleanType")
    private Boolean isActive;

    @Column(name = "is_delete")
    @Type(type = "org.hibernate.type.NumericBooleanType")
    private Boolean isDelete;

}
