package com.iconplus.smartproc.model.entity;

import com.iconplus.smartproc.helper.base.BaseEntity;
import lombok.AllArgsConstructor;
import lombok.Builder;
import lombok.Data;
import lombok.NoArgsConstructor;
import org.hibernate.annotations.Type;

import javax.persistence.*;
import java.sql.Timestamp;

@Data
@Builder
@AllArgsConstructor
@NoArgsConstructor
@Entity
@Table(name = "users")
public class Users extends BaseEntity {
    @Id
    @GeneratedValue(strategy = GenerationType.IDENTITY)
    @Column(name = "id")
    private Long id;

    @Column(name = "username")
    private String username;

    @Column(name = "nama")
    private String nama;

    @Column(name = "email")
    private String email;

    @Column(name = "telepon")
    private String telepon;

    @Column(name = "password")
    private String password;

    @Column(name = "instansi_id")
    private Long instansiId;

    @Column(name = "bidang_id")
    private Long bidangId;

    @Column(name = "jabatan_id")
    private Long jabatanId;

    @Column(name = "role_id")
    private Long roleId;

    @Column(name = "remember_id")
    private String rememberId;

    @Column(name = "expired_time")
    private Timestamp expiredTime;

    @Column(name = "is_active")
    @Type(type = "org.hibernate.type.NumericBooleanType")
    private Boolean isActive;

    @Column(name = "is_delete")
    @Type(type = "org.hibernate.type.NumericBooleanType")
    private Boolean isDelete;
}
