package com.iconplus.smartproc.model.request;

import com.iconplus.smartproc.helper.base.BaseRequest;
import lombok.AllArgsConstructor;
import lombok.Builder;
import lombok.Data;
import lombok.NoArgsConstructor;
import org.springframework.data.domain.Pageable;

import java.math.BigDecimal;
import java.sql.Date;
import java.sql.Timestamp;
import java.util.List;

@Data
@Builder
@AllArgsConstructor
@NoArgsConstructor
public class DrpPengadaanRequest extends BaseRequest {

    private Long id;
    private Long drpId;
    private String nomor;
    private String namaPengadaan;
    private Long lokasiId;
    private Long jenisPengadaanId;
    private Long unitInisiatorId;
    private BigDecimal pagu;
    private Long sumberDanaId;
    private Long supplyPositioningMatrixId;
    private Long metodePengadaanId;
    private Long metodePenyampaianId;
    private Long jenisKontrakId;
    private Long strategiPengadaanId;
    private Date rencanaTanggal;
    private Date targetTanggal;
    private BigDecimal hpe;
    private Boolean isActive;
    private Boolean isDelete;

    private List<DrpPengadaanDokumenRequest> dataDrpPengadaanDokumen;

    private transient Pageable pageable;

}
