package com.iconplus.smartproc.repository;

import com.iconplus.smartproc.model.entity.Bidang;
import com.iconplus.smartproc.model.projection.BidangView;
import org.springframework.data.domain.Page;
import org.springframework.data.domain.Pageable;
import org.springframework.data.jpa.repository.JpaRepository;
import org.springframework.data.jpa.repository.Query;
import org.springframework.stereotype.Repository;

import java.util.Optional;

@Repository
public interface BidangRepository extends JpaRepository<Bidang, LokasiRepository> {

    @Query(value = "SELECT b.id as id, " +
            "b.instansiId as instansiId, " +
            "i.instansi as instansi, " +
            "b.bidang as bidang, " +
            "b.keterangan as keterangan, " +
            "b.isActive as isActive " +
            "FROM Bidang b " +
            "JOIN Instansi i on i.id = b.instansiId " +
            "WHERE b.isDelete = false " +
            "AND (:search='' or UPPER(b.bidang) like :search) " +
            "ORDER BY b.id")
    Page<BidangView> getListBidang(String search, Pageable pageable);

    Optional<Bidang> findByIdAndIsDeleteFalse(Long id);

    Optional<Bidang> findByBidangAndIsDeleteFalse(String bidang);
}
