package com.iconplus.smartproc.repository;

import com.iconplus.smartproc.model.entity.MetodePenyampaian;
import com.iconplus.smartproc.model.projection.MetodePenyampaianView;
import org.springframework.data.domain.Page;
import org.springframework.data.domain.Pageable;
import org.springframework.data.jpa.repository.JpaRepository;
import org.springframework.data.jpa.repository.Query;
import org.springframework.stereotype.Repository;

import java.util.Optional;

@Repository
public interface MetodePenyampaianRepository extends JpaRepository<MetodePenyampaian, Long> {

    @Query(value = "SELECT mp.id as id, " +
            "mp.metodePenyampaian as metodePenyampaian, " +
            "mp.keterangan as keterangan, " +
            "mp.isActive as isActive, " +
            "mp.isDelete as isDelete " +
            "FROM MetodePenyampaian mp " +
            "WHERE mp.isDelete = false " +
            "AND (:search = '' " +
            "or UPPER(mp.metodePenyampaian) like :search) " +
            "ORDER BY mp.id")
    Page<MetodePenyampaianView> getAllMetodePenyampaian(String search, Pageable pageable);

    Optional<MetodePenyampaian> findByIdAndIsDeleteFalse(Long id);

    Optional<MetodePenyampaian> findByMetodePenyampaianAndIsDeleteFalse(String metodePenyampaian);
    
}
