package com.iconplus.smartproc.repository;

import com.iconplus.smartproc.model.projection.SupplyPositioningMatrixView;
import org.springframework.data.domain.Page;
import org.springframework.data.domain.Pageable;
import org.springframework.data.jpa.repository.JpaRepository;
import org.springframework.data.jpa.repository.Query;
import org.springframework.stereotype.Repository;
import com.iconplus.smartproc.model.entity.SupplyPositioningMatrix;

import java.util.Optional;

@Repository
public interface SupplyPositioningMatrixRepository extends JpaRepository<SupplyPositioningMatrix, Long> {

    @Query(value = "SELECT spm.id as id, " +
            "spm.supplyPositioningMatrix as supplyPositioningMatrix, " +
            "spm.keterangan as keterangan, " +
            "spm.isActive as isActive, " +
            "spm.isDelete as isDelete " +
            "FROM SupplyPositioningMatrix spm " +
            "WHERE spm.isDelete = false " +
            "AND (:search = '' " +
            "or UPPER(spm.supplyPositioningMatrix) like :search) " +
            "ORDER BY spm.id")
    Page<SupplyPositioningMatrixView> getAllSupplyPositioningMatrix(String search, Pageable pageable);

    Optional<SupplyPositioningMatrix> findByIdAndIsDeleteFalse(Long id);

    Optional<SupplyPositioningMatrix> findBySupplyPositioningMatrixAndIsDeleteFalse(String supplyPositioningMatrix);
    
}
