package com.iconplus.smartproc.service.bidang;

import com.iconplus.smartproc.exception.BusinessException;
import com.iconplus.smartproc.helper.service.BaseService;
import com.iconplus.smartproc.model.request.BidangRequest;
import com.iconplus.smartproc.model.response.BidangResponse;
import com.iconplus.smartproc.repository.BidangRepository;
import com.iconplus.smartproc.util.Constants;
import org.springframework.stereotype.Service;

@Service
public class GetBidangService implements BaseService<BidangRequest, BidangResponse> {

    private BidangRepository bidangRepository;

    public GetBidangService(BidangRepository bidangRepository) {
        this.bidangRepository = bidangRepository;
    }

    @Override
    public BidangResponse execute(BidangRequest input) {

        var bidang = bidangRepository.findByIdAndIsDeleteFalse(input.getId())
                .orElseThrow(() -> new BusinessException(Constants.ERR_CODE_10001,
                        Constants.ERR_TTL_10001,
                        String.format(Constants.ERR_MSG_10001, "Bidang", input.getId())));

        return BidangResponse.builder()
                .id(bidang.getId())
                .instansiId(bidang.getInstansiId())
                .bidang(bidang.getBidang())
                .keterangan(bidang.getKeterangan())
                .isActive(bidang.getIsActive())
                .build();
    }
}
