package com.iconplus.smartproc.service.drp;

import com.iconplus.smartproc.helper.model.EmptyResponse;
import com.iconplus.smartproc.helper.service.BaseService;
import com.iconplus.smartproc.model.entity.DrpDokumen;
import com.iconplus.smartproc.model.request.DrpDokumenRequest;
import com.iconplus.smartproc.model.response.DrpDokumenResponse;
import com.iconplus.smartproc.repository.DrpDokumenRepository;
import org.springframework.beans.factory.annotation.Value;
import org.springframework.stereotype.Service;
import org.springframework.web.multipart.MultipartFile;

import java.io.File;
import java.io.FileOutputStream;
import java.io.IOException;

@Service
public class PostDrpUploadDokumenPendukungService implements BaseService<DrpDokumenRequest, DrpDokumenResponse> {

    @Value("${config.file-upload.pendukung}")
    private String pathFileUploadPendukung;

    private final DrpDokumenRepository drpDokumenRepository;
    public PostDrpUploadDokumenPendukungService(DrpDokumenRepository drpDokumenRepository) {
        this.drpDokumenRepository = drpDokumenRepository;
    }

    @Override
    public DrpDokumenResponse execute(DrpDokumenRequest input) throws IOException {

        MultipartFile file = input.getFile();
        String fileName = file.getOriginalFilename();

        File path = new File(pathFileUploadPendukung + fileName);

        path.createNewFile();
        FileOutputStream output = new FileOutputStream(path);
        output.write(file.getBytes());
        output.close();

        return DrpDokumenResponse.builder()
                .jenisDokumenId(input.getJenisDokumenId())
                .filename(fileName)
                .keterangan(input.getKeterangan())
                .build();
    }
}
