package com.iconplus.smartproc.service.jeniskontrak;

import com.iconplus.smartproc.helper.model.Pagination;
import com.iconplus.smartproc.helper.service.BaseService;
import com.iconplus.smartproc.model.projection.JenisKontrakView;
import com.iconplus.smartproc.model.request.JenisKontrakRequest;
import com.iconplus.smartproc.model.response.GetListJenisKontrakResponse;
import com.iconplus.smartproc.model.response.JenisKontrakResponse;
import com.iconplus.smartproc.repository.JenisKontrakRepository;
import org.apache.commons.lang3.StringUtils;
import org.springframework.stereotype.Service;

import java.util.ArrayList;
import java.util.List;


@Service
public class GetListJenisKontrakService implements BaseService<JenisKontrakRequest, GetListJenisKontrakResponse> {

    private JenisKontrakRepository jenisKontrakRepository;

    public GetListJenisKontrakService(JenisKontrakRepository jenisKontrakRepository) {
        this.jenisKontrakRepository = jenisKontrakRepository;
    }

    @Override
    public GetListJenisKontrakResponse execute(JenisKontrakRequest input) {
        validateRequest(input);
        List<JenisKontrakResponse> jenisKontrakResponseList = new ArrayList<>();
        var jenisKontrakViews =  jenisKontrakRepository.getAllJenisKontrak(input.getSearch(), input.getPageable());

        for (JenisKontrakView jenisKontrakView : jenisKontrakViews) {
            JenisKontrakResponse jenisKontrakResponse = JenisKontrakResponse.builder()
                    .id(jenisKontrakView.getId())
                    .jenisKontrak(jenisKontrakView.getJenisKontrak())
                    .keterangan(jenisKontrakView.getKeterangan())
                    .isActive(jenisKontrakView.getIsActive())
                    .isDelete(jenisKontrakView.getIsDelete())
                    .build();
            jenisKontrakResponseList.add(jenisKontrakResponse);
        }

        return GetListJenisKontrakResponse.builder()
                .data(jenisKontrakResponseList)
                .pagination(Pagination.builder()
                        .pageSize(input.getPageable().getPageSize())
                        .currentPage(input.getPageable().getPageNumber())
                        .totalPages(jenisKontrakViews.getTotalPages())
                        .totalRecords(jenisKontrakViews.getTotalElements())
                        .isFirstPage(jenisKontrakViews.isFirst())
                        .isLastPage(jenisKontrakViews.isLast())
                        .build())
                .build();
    }

    private void validateRequest(JenisKontrakRequest input) {
        if (StringUtils.isNotBlank(input.getSearch())) {
            input.setSearch('%'+ input.getSearch().toUpperCase()+'%');
        }
    }
}
