package com.iconplus.smartproc.service.jeniskontrak;

import com.iconplus.smartproc.exception.BusinessException;
import com.iconplus.smartproc.helper.service.BaseService;
import com.iconplus.smartproc.model.request.JenisKontrakRequest;
import com.iconplus.smartproc.model.response.JenisKontrakResponse;
import com.iconplus.smartproc.repository.JenisKontrakRepository;
import com.iconplus.smartproc.util.Constants;
import lombok.extern.slf4j.Slf4j;
import org.springframework.http.HttpStatus;
import org.springframework.stereotype.Service;


@Service
@Slf4j
public class PutUpdateJenisKontrakService implements BaseService<JenisKontrakRequest, JenisKontrakResponse> {

    private JenisKontrakRepository jenisKontrakRepository;

    public PutUpdateJenisKontrakService(JenisKontrakRepository jenisKontrakRepository) {
        this.jenisKontrakRepository = jenisKontrakRepository;
    }

    @Override
    public JenisKontrakResponse execute(JenisKontrakRequest input) {

        var jenisKontrak = jenisKontrakRepository.findByIdAndIsDeleteFalse(input.getId())
                .orElseThrow(() -> new BusinessException(HttpStatus.CONFLICT,
                        Constants.ERR_CODE_10001,
                        Constants.ERR_TTL_10001,
                        String.format(Constants.ERR_MSG_10001, "Jenis Kontrak", input.getId())));

        jenisKontrak.setJenisKontrak(input.getJenisKontrak());
        jenisKontrak.setKeterangan(input.getKeterangan());
        jenisKontrak.setIsActive(input.getIsActive());
        jenisKontrakRepository.save(jenisKontrak);
        log.info("Success edit jenis kontrak id {}", jenisKontrak.getId());
        return JenisKontrakResponse.builder()
                .id(jenisKontrak.getId())
                .build();
    }
}
