package com.iconplus.smartproc.service.sumberdana;

import com.iconplus.smartproc.exception.BusinessException;
import com.iconplus.smartproc.helper.model.EmptyResponse;
import com.iconplus.smartproc.helper.service.BaseService;
import com.iconplus.smartproc.model.request.SumberDanaRequest;
import com.iconplus.smartproc.repository.SumberDanaRepository;
import com.iconplus.smartproc.util.Constants;
import org.springframework.http.HttpStatus;
import org.springframework.stereotype.Service;

@Service
public class DeleteSumberDanaService implements BaseService<SumberDanaRequest, EmptyResponse> {

    private SumberDanaRepository sumberDanaRepository;

    public DeleteSumberDanaService(SumberDanaRepository sumberDanaRepository) {
        this.sumberDanaRepository = sumberDanaRepository;
    }

    @Override
    public EmptyResponse execute(SumberDanaRequest input) {
        var sumberDana = sumberDanaRepository.findByIdAndIsDeleteFalse(input.getId())
                .orElseThrow(() -> new BusinessException(HttpStatus.CONFLICT,
                        Constants.ERR_CODE_10001,
                        Constants.ERR_TTL_10001,
                        String.format(Constants.ERR_MSG_10001, "Sumber Dana", input.getId())));
        sumberDana.setIsDelete(true);
        sumberDanaRepository.save(sumberDana);
        return new EmptyResponse();
    }
}
