package com.iconplus.smartproc.service.unitinisiator;

import com.iconplus.smartproc.exception.BusinessException;
import com.iconplus.smartproc.helper.service.BaseService;
import com.iconplus.smartproc.model.request.UnitInisiatorRequest;
import com.iconplus.smartproc.model.response.UnitInisiatorResponse;
import com.iconplus.smartproc.repository.UnitInisiatorRepository;
import com.iconplus.smartproc.util.Constants;
import org.springframework.http.HttpStatus;
import org.springframework.stereotype.Service;

@Service
public class GetUnitInisiatorService implements BaseService<UnitInisiatorRequest, UnitInisiatorResponse> {

    private UnitInisiatorRepository unitInisiatorRepository;

    private GetUnitInisiatorService(UnitInisiatorRepository unitInisiatorRepository) {
        this.unitInisiatorRepository = unitInisiatorRepository;
    }

    @Override
    public UnitInisiatorResponse execute(UnitInisiatorRequest input) {

        var unitInisiator = unitInisiatorRepository.findByIdAndIsDeleteFalse(input.getId())
                .orElseThrow(() -> new BusinessException(HttpStatus.CONFLICT,
                        Constants.ERR_CODE_10001,
                        Constants.ERR_TTL_10001,
                        String.format(Constants.ERR_MSG_10001, "Unit Inisiator", input.getId())));
        return UnitInisiatorResponse.builder()
                .id(unitInisiator.getId())
                .unitInisiator(unitInisiator.getUnitInisiator())
                .keterangan(unitInisiator.getKeterangan())
                .isActive(unitInisiator.getIsActive())
                .isDelete(unitInisiator.getIsDelete())
                .build();

    }
}
